module base_types

export get_base_type

BASE_TYPE_DICT = Dict(
    0x00 => Enum,
    0x01 => Int8,
    0x02 => UInt8,
    0x83 => Int16,
    0x84 => UInt16,
    0x85 => Int32,
    0x86 => UInt32,
    0x07 => AbstractString,
    0x88 => Float32,
    0x89 => Float64,
    0x0a => UInt8, #z?
    0x8b => UInt16, #z?
    0x8c => UInt32, #z?
    0x0d => UInt8, # Byte
    0x8e => Int64,
    0x8f => UInt64,
    0x90 => UInt64 #z?
)

function get_base_type(num::UInt8)::Type
    BASE_TYPE_DICT[num]
end

end
